Bug 1258619 - Ruby traceback on pcsd startup - /webrick.rb:48:in `shutdown': undefined method `shutdown'
Ruby traceback on pcsd startup - /webrick.rb:48:in `shutdown': undefined met...
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: pcs (Show other bugs)
7.2
Unspecified Unspecified
high Severity high
: rc
: ---
Assigned To: Chris Feist
cluster-qe@redhat.com
: Regression
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-08-31 15:20 EDT by Jaroslav Kortus
Modified: 2015-11-19 04:38 EST (History)
4 users (show)

See Also:
Fixed In Version: pcs-0.9.143-4.el7
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-11-19 04:38:45 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jaroslav Kortus 2015-08-31 15:20:17 EDT
Description of problem:
Traceback produced at startup:

/usr/lib/pcsd/vendor/bundle/ruby/gems/rack-1.6.4/lib/rack/handler/webrick.rb:48:in `shutdown': undefined method `shutdown' for
 nil:NilClass (NoMethodError)
        from /usr/lib/pcsd/ssl.rb:56:in `block in <main>'
        from /usr/lib/pcsd/ssl.rb:1:in `call'


Version-Release number of selected component (if applicable):
pcs-0.9.143-2.el7

How reproducible:
100%

Steps to Reproduce:
1. service pcsd start
2.
3.

Actual results:
ruby traceback (triggers abrt)

Expected results:
no traceback


Additional info:
Comment 4 Chris Feist 2015-08-31 16:14:21 EDT
Fixes upstream here:

https://github.com/feist/pcs/commit/4d4ad9fc870998f4e70256ef62371f38da3a4855
Comment 5 Chris Feist 2015-08-31 17:32:11 EDT
Before Fix:
[root@virt-028 abrt]# rpm -q pcs
pcs-0.9.143-2.el7.x86_64
[root@virt-028 abrt]# service pcsd start ; sleep 5 ; service pcsd stop
Redirecting to /bin/systemctl start  pcsd.service
Redirecting to /bin/systemctl stop  pcsd.service


abrt is generated, this is at the end of /var/lib/pcsd.log:
[root@virt-028 abrt]# tail -n15 /var/log/pcsd/pcsd.log 
- -> /remote/get_configs
Shutting down (TERM)
[2015-08-31 23:29:18] INFO  going to shutdown ...
Shutting down (TERM)
/usr/lib/pcsd/vendor/bundle/ruby/gems/rack-1.6.4/lib/rack/handler/webrick.rb:48:in `shutdown': undefined method `shutdown' for nil:NilClass (NoMethodError)
	from /usr/lib/pcsd/ssl.rb:56:in `block in <main>'
	from /usr/share/ruby/webrick/server.rb:198:in `call'
	from /usr/share/ruby/webrick/server.rb:198:in `join'
	from /usr/share/ruby/webrick/server.rb:198:in `block (2 levels) in start'
	from /usr/share/ruby/webrick/server.rb:198:in `each'
	from /usr/share/ruby/webrick/server.rb:198:in `block in start'
	from /usr/share/ruby/webrick/server.rb:32:in `start'
	from /usr/share/ruby/webrick/server.rb:160:in `start'
	from /usr/lib/pcsd/vendor/bundle/ruby/gems/rack-1.6.4/lib/rack/handler/webrick.rb:34:in `run'
	from /usr/lib/pcsd/ssl.rb:62:in `<main>'



After fix:
[root@virt-028 abrt]# rpm -q pcs
pcs-0.9.143-4.el7.x86_64
[root@virt-028 abrt]# service pcsd start ; sleep 5 ; service pcsd stop
Redirecting to /bin/systemctl start  pcsd.service
Redirecting to /bin/systemctl stop  pcsd.service
[root@virt-028 abrt]# tail -n5 /var/log/pcsd/pcsd.log 
virt-028.cluster-qe.lab.eng.brq.redhat.com - - [31/Aug/2015:23:31:15 CEST] "GET /remote/get_configs HTTP/1.1" 200 538
- -> /remote/get_configs
Shutting down (TERM)
[2015-08-31 23:31:15] INFO  going to shutdown ...
Shutting down (TERM)


No abrt generated
Comment 7 Radek Steiger 2015-09-08 07:51:54 EDT
BEFORE FIX:

[root@virt-142 ~]# rpm -q pcs
pcs-0.9.143-3.el7.x86_64

[root@virt-142 ~]# systemctl stop pcsd
You have new mail in /var/spool/mail/root

[root@virt-142 ~]# tail -n14 /var/log/pcsd/pcsd.log 
Shutting down (TERM)
[2015-09-08 13:45:14] INFO  going to shutdown ...
Shutting down (TERM)
/usr/lib/pcsd/vendor/bundle/ruby/gems/rack-1.6.4/lib/rack/handler/webrick.rb:48:in `shutdown': undefined method `shutdown' for nil:NilClass (NoMethodError)
	from /usr/lib/pcsd/ssl.rb:56:in `block in <main>'
	from /usr/share/ruby/webrick/server.rb:198:in `call'
	from /usr/share/ruby/webrick/server.rb:198:in `join'
	from /usr/share/ruby/webrick/server.rb:198:in `block (2 levels) in start'
	from /usr/share/ruby/webrick/server.rb:198:in `each'
	from /usr/share/ruby/webrick/server.rb:198:in `block in start'
	from /usr/share/ruby/webrick/server.rb:32:in `start'
	from /usr/share/ruby/webrick/server.rb:160:in `start'
	from /usr/lib/pcsd/vendor/bundle/ruby/gems/rack-1.6.4/lib/rack/handler/webrick.rb:34:in `run'
	from /usr/lib/pcsd/ssl.rb:62:in `<main>'

An abrt report is generated and a traceback appears in logs.



AFTER FIX:

[root@virt-142 pcsd]# rpm -q pcs
pcs-0.9.143-8.el7.x86_64

[root@virt-142 pcsd]# systemctl stop pcsd

[root@virt-142 pcsd]# tail -n3 /var/log/pcsd/pcsd.log 
Shutting down (TERM)
[2015-09-08 13:42:51] INFO  going to shutdown ...
Shutting down (TERM)

No abrt and no traceback in logs.



VERIFIED in pcs-0.9.143-8.el7
Comment 9 errata-xmlrpc 2015-11-19 04:38:45 EST
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2015-2290.html

Note You need to log in before you can comment on or make changes to this bug.